diff --git a/src/connection-editor/nm-connection-editor.h b/src/connection-editor/nm-connection-editor.h
index f3daf72..4bf3178 100644
--- a/src/connection-editor/nm-connection-editor.h
+++ b/src/connection-editor/nm-connection-editor.h
@@ -39,6 +39,7 @@
 #define NM_SYSCONFIG_POLICY_ACTION_SYSTEM_MOBILE_MODIFY "org.freedesktop.network-manager-settings.system.mobile.modify"
 #define NM_SYSCONFIG_POLICY_ACTION_SYSTEM_VPN_MODIFY "org.freedesktop.network-manager-settings.system.vpn.modify"
 #define NM_SYSCONFIG_POLICY_ACTION_SYSTEM_DSL_MODIFY "org.freedesktop.network-manager-settings.system.dsl.modify"
+#define NM_SYSCONFIG_POLICY_ACTION_SYSTEM_MODEM_MODIFY "org.freedesktop.network-manager-settings.system.modem.modify"
 
 #define NM_TYPE_CONNECTION_EDITOR    (nm_connection_editor_get_type ())
 #define NM_IS_CONNECTION_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NM_TYPE_CONNECTION_EDITOR))
diff --git a/src/connection-editor/nm-connection-list.c b/src/connection-editor/nm-connection-list.c
index c254e52..2bbbcd1 100644
--- a/src/connection-editor/nm-connection-list.c
+++ b/src/connection-editor/nm-connection-list.c
@@ -46,6 +46,7 @@
 #include <nm-setting-gsm.h>
 #include <nm-setting-cdma.h>
 #include <nm-setting-pppoe.h>
+#include <nm-setting-analog-modem.h>
 #include <nm-setting-ppp.h>
 #include <nm-setting-serial.h>
 #include <nm-vpn-plugin-ui-interface.h>
@@ -916,6 +917,23 @@ create_new_connection_for_type (NMConnectionList *list, const char *connection_t
 		} else {
 			/* user canceled; do nothing */
 		}
+	} else if (ctype == NM_TYPE_SETTING_ANALOG_MODEM) {
+		NMSettingAnalogModem *s_analog_modem;
+
+		id = get_next_available_name (list, _("Modem connection %d"));
+		g_object_set (s_con,
+					  NM_SETTING_CONNECTION_ID, id,
+					  NM_SETTING_CONNECTION_TYPE, NM_SETTING_ANALOG_MODEM_SETTING_NAME,
+					  NM_SETTING_CONNECTION_AUTOCONNECT, FALSE,
+					  NULL);
+		g_free (id);
+
+		add_default_serial_setting (connection);
+
+		type_setting = nm_setting_analog_modem_new ();
+		s_analog_modem = NM_SETTING_ANALOG_MODEM (type_setting);
+
+		nm_connection_add_setting (connection, nm_setting_ppp_new ());
 	} else if (ctype == NM_TYPE_SETTING_VPN) {
 		char *service = NULL;
 
@@ -1454,6 +1472,8 @@ dispose (GObject *object)
 		g_object_unref (list->wireless_icon);
 	if (list->wwan_icon)
 		g_object_unref (list->wwan_icon);
+	if (list->modem_icon)
+		g_object_unref (list->modem_icon);
 	if (list->vpn_icon)
 		g_object_unref (list->vpn_icon);
 	if (list->unknown_icon)
@@ -1829,6 +1849,9 @@ add_connection_tabs (NMConnectionList *self, const char *def_type)
 
 	types = g_slist_append (NULL, NM_SETTING_PPPOE_SETTING_NAME);
 	add_connection_tab (self, def_type, types, self->wired_icon, "dsl", _("DSL"), FALSE);
+
+	types = g_slist_append (NULL, NM_SETTING_ANALOG_MODEM_SETTING_NAME);
+	add_connection_tab (self, def_type, types, self->modem_icon, "modem", _("Modem"), FALSE);
 }
 
 static void
@@ -1924,6 +1947,7 @@ nm_connection_list_new (const char *def_type)
 	ICON_LOAD(list->wired_icon, "nm-device-wired");
 	ICON_LOAD(list->wireless_icon, "nm-device-wireless");
 	ICON_LOAD(list->wwan_icon, "nm-device-wwan");
+	ICON_LOAD(list->modem_icon, "stock_landline-phone");
 	ICON_LOAD(list->vpn_icon, "nm-vpn-standalone-lock");
 	ICON_LOAD(list->unknown_icon, "nm-no-connection");
 
diff --git a/src/connection-editor/nm-connection-list.h b/src/connection-editor/nm-connection-list.h
index 800873a..ae32ba7 100644
--- a/src/connection-editor/nm-connection-list.h
+++ b/src/connection-editor/nm-connection-list.h
@@ -59,6 +59,7 @@ typedef struct {
 	GdkPixbuf *wired_icon;
 	GdkPixbuf *wireless_icon;
 	GdkPixbuf *wwan_icon;
+	GdkPixbuf *modem_icon;
 	GdkPixbuf *vpn_icon;
 	GdkPixbuf *unknown_icon;
 	GtkIconTheme *icon_theme;
diff --git a/src/connection-editor/page-ip4.c b/src/connection-editor/page-ip4.c
index bc23a4a..759540b 100644
--- a/src/connection-editor/page-ip4.c
+++ b/src/connection-editor/page-ip4.c
@@ -37,6 +37,7 @@
 #include <nm-setting-cdma.h>
 #include <nm-setting-pppoe.h>
 #include <nm-setting-vpn.h>
+#include <nm-setting-analog-modem.h>
 #include <nm-utils.h>
 
 #include "page-ip4.h"
@@ -116,7 +117,8 @@ ip4_private_init (CEPageIP4 *self, NMConnection *connection)
 		str_auto = _("Automatic (VPN)");
 		str_auto_only = _("Automatic (VPN) addresses only");
 	} else if (   priv->connection_type == NM_TYPE_SETTING_GSM
-	           || priv->connection_type == NM_TYPE_SETTING_CDMA) {
+	           || priv->connection_type == NM_TYPE_SETTING_CDMA
+	           || priv->connection_type == NM_TYPE_SETTING_ANALOG_MODEM) {
 		str_auto = _("Automatic (PPP)");
 		str_auto_only = _("Automatic (PPP) addresses only");
 	} else if (priv->connection_type == NM_TYPE_SETTING_PPPOE) {
@@ -143,9 +145,10 @@ ip4_private_init (CEPageIP4 *self, NMConnection *connection)
 	                    METHOD_COL_NUM, IP4_METHOD_AUTO_ADDRESSES,
 	                    -1);
 
-	/* Manual is pointless for Mobile Broadband */
+	/* Manual is pointless for Mobile Broadband and dial-up */
 	if (   priv->connection_type != NM_TYPE_SETTING_GSM
 	    && priv->connection_type != NM_TYPE_SETTING_CDMA
+	    && priv->connection_type != NM_TYPE_SETTING_ANALOG_MODEM
 	    && priv->connection_type != NM_TYPE_SETTING_VPN) {
 		gtk_list_store_append (priv->method_store, &iter);
 		gtk_list_store_set (priv->method_store, &iter,
@@ -192,6 +195,7 @@ ip4_private_init (CEPageIP4 *self, NMConnection *connection)
 	if (   priv->connection_type == NM_TYPE_SETTING_VPN
 	    || priv->connection_type == NM_TYPE_SETTING_GSM
 	    || priv->connection_type == NM_TYPE_SETTING_CDMA
+	    || priv->connection_type == NM_TYPE_SETTING_ANALOG_MODEM
 	    || priv->connection_type == NM_TYPE_SETTING_PPPOE) {
 		gtk_widget_hide (GTK_WIDGET (priv->dhcp_client_id_label));
 		gtk_widget_hide (GTK_WIDGET (priv->dhcp_client_id));
@@ -238,6 +242,7 @@ method_changed (GtkComboBox *combo, gpointer user_data)
 	if (   priv->connection_type == NM_TYPE_SETTING_VPN
 	    || priv->connection_type == NM_TYPE_SETTING_GSM
 	    || priv->connection_type == NM_TYPE_SETTING_CDMA
+	    || priv->connection_type == NM_TYPE_SETTING_ANALOG_MODEM
 	    || priv->connection_type == NM_TYPE_SETTING_PPPOE)
 		dhcp_enabled = FALSE;
 
diff --git a/src/connection-editor/page-modem.c b/src/connection-editor/page-modem.c
new file mode 100644
index 0000000..5ec524d
--- /dev/null
+++ b/src/connection-editor/page-modem.c
@@ -0,0 +1,286 @@
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* NetworkManager Connection editor -- Connection editor for NetworkManager
+ *
+ * Dan Williams <dcbw@redhat.com>
+ * Hans Petter Jansson <hpj@novell.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * (C) Copyright 2008 - 2010 Red Hat, Inc.
+ * (C) Copyright 2010 Novell, Inc.
+ */
+
+#include <string.h>
+
+#include <gtk/gtk.h>
+#include <glib/gi18n.h>
+
+#include <nm-setting-connection.h>
+#include <nm-setting-analog-modem.h>
+#include <nm-setting-serial.h>
+#include <nm-setting-ppp.h>
+
+#include "page-modem.h"
+#include "nm-connection-editor.h"
+#include "gconf-helpers.h"
+
+G_DEFINE_TYPE (CEPageModem, ce_page_modem, CE_TYPE_PAGE)
+
+#define CE_PAGE_MODEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CE_TYPE_PAGE_MODEM, CEPageModemPrivate))
+
+typedef struct {
+	NMSettingAnalogModem *setting;
+
+	GtkEntry *prefix;
+	GtkEntry *number;
+	GtkEntry *username;
+	GtkEntry *password;
+
+	GtkCheckButton *speaker;
+	GtkCheckButton *dialtone;
+
+	GtkWindowGroup *window_group;
+	gboolean window_added;
+
+	gboolean disposed;
+} CEPageModemPrivate;
+
+static void
+modem_private_init (CEPageModem *self)
+{
+	CEPageModemPrivate *priv = CE_PAGE_MODEM_GET_PRIVATE (self);
+	GladeXML *xml;
+
+	xml = CE_PAGE (self)->xml;
+
+	priv->prefix = GTK_ENTRY (glade_xml_get_widget (xml, "modem_prefix"));
+	priv->number = GTK_ENTRY (glade_xml_get_widget (xml, "modem_number"));
+	priv->username = GTK_ENTRY (glade_xml_get_widget (xml, "modem_username"));
+	priv->password = GTK_ENTRY (glade_xml_get_widget (xml, "modem_password"));
+	priv->speaker = GTK_CHECK_BUTTON (glade_xml_get_widget (xml, "modem_speaker"));
+	priv->dialtone = GTK_CHECK_BUTTON (glade_xml_get_widget (xml, "modem_dialtone"));
+
+	priv->window_group = gtk_window_group_new ();
+}
+
+static void
+populate_modem_ui (CEPageModem *self, NMConnection *connection)
+{
+	CEPageModemPrivate *priv = CE_PAGE_MODEM_GET_PRIVATE (self);
+	NMSettingAnalogModem *setting = NM_SETTING_ANALOG_MODEM (priv->setting);
+	GHashTable *secrets = NULL;
+	const char *s;
+	gboolean b;
+
+	s = nm_setting_analog_modem_get_prefix (setting);
+	if (s)
+		gtk_entry_set_text (priv->prefix, s);
+
+	s = nm_setting_analog_modem_get_number (setting);
+	if (s)
+		gtk_entry_set_text (priv->number, s);
+
+	s = nm_setting_analog_modem_get_username (setting);
+	if (s)
+		gtk_entry_set_text (priv->username, s);
+
+	s = nm_setting_analog_modem_get_password (setting);
+	if (!s) {
+		GError *error = NULL;
+		GValue *value;
+
+		secrets = nm_gconf_get_keyring_items (connection,
+		                                      nm_setting_get_name (NM_SETTING (setting)),
+		                                      FALSE,
+		                                      &error);
+		if (secrets) {
+			value = g_hash_table_lookup (secrets, NM_SETTING_ANALOG_MODEM_PASSWORD);
+			if (value)
+				s = g_value_get_string (value);
+		} else if (error)
+			g_error_free (error);
+	}
+	if (s)
+		gtk_entry_set_text (priv->password, s);
+	if (secrets)
+		g_hash_table_destroy (secrets);
+
+	b = nm_setting_analog_modem_get_enable_speaker (setting);
+	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (priv->speaker), b);
+
+	b = nm_setting_analog_modem_get_detect_dialtone (setting);
+	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (priv->dialtone), b);
+}
+
+static void
+stuff_changed (GtkWidget *w, gpointer user_data)
+{
+	ce_page_changed (CE_PAGE (user_data));
+}
+
+static void
+show_passwords (GtkToggleButton *button, gpointer user_data)
+{
+	CEPageModemPrivate *priv = CE_PAGE_MODEM_GET_PRIVATE (user_data);
+	gboolean active;
+
+	active = gtk_toggle_button_get_active (button);
+
+	gtk_entry_set_visibility (priv->password, active);
+}
+
+static void
+finish_setup (CEPageModem *self, gpointer unused, GError *error, gpointer user_data)
+{
+	CEPage *parent = CE_PAGE (self);
+	CEPageModemPrivate *priv = CE_PAGE_MODEM_GET_PRIVATE (self);
+
+	if (error)
+		return;
+
+	if (NM_IS_SETTING_ANALOG_MODEM (priv->setting))
+		populate_modem_ui (self, parent->connection);
+	else
+		g_assert_not_reached ();
+
+	g_signal_connect (priv->prefix, "changed", G_CALLBACK (stuff_changed), self);
+	g_signal_connect (priv->number, "changed", G_CALLBACK (stuff_changed), self);
+	g_signal_connect (priv->username, "changed", G_CALLBACK (stuff_changed), self);
+	g_signal_connect (priv->password, "changed", G_CALLBACK (stuff_changed), self);
+	g_signal_connect (priv->speaker, "toggled", G_CALLBACK (stuff_changed), self);
+	g_signal_connect (priv->dialtone, "toggled", G_CALLBACK (stuff_changed), self);
+
+	g_signal_connect (glade_xml_get_widget (parent->xml, "modem_show_passwords"),
+	                  "toggled",
+	                  G_CALLBACK (show_passwords),
+	                  self);
+}
+
+CEPage *
+ce_page_modem_new (NMConnection *connection,
+                    GtkWindow *parent_window,
+                    GError **error)
+{
+	CEPageModem *self;
+	CEPageModemPrivate *priv;
+	CEPage *parent;
+
+	self = CE_PAGE_MODEM (g_object_new (CE_TYPE_PAGE_MODEM,
+										CE_PAGE_CONNECTION, connection,
+										CE_PAGE_PARENT_WINDOW, parent_window,
+										NULL));
+	parent = CE_PAGE (self);
+
+	parent->xml = glade_xml_new (GLADEDIR "/ce-page-modem.glade", "ModemPage", NULL);
+	if (!parent->xml) {
+		g_set_error (error, 0, 0, "%s", _("Could not load modem user interface."));
+		g_object_unref (self);
+		return NULL;
+	}
+
+	parent->page = glade_xml_get_widget (parent->xml, "ModemPage");
+	if (!parent->page) {
+		g_set_error (error, 0, 0, "%s", _("Could not load modem user interface."));
+		g_object_unref (self);
+		return NULL;
+	}
+	g_object_ref_sink (parent->page);
+
+	parent->title = g_strdup (_("Modem"));
+
+	modem_private_init (self);
+	priv = CE_PAGE_MODEM_GET_PRIVATE (self);
+
+	priv->setting = (NMSettingAnalogModem *) nm_connection_get_setting (connection, NM_TYPE_SETTING_ANALOG_MODEM);
+	if (!priv->setting) {
+		priv->setting = NM_SETTING_ANALOG_MODEM (nm_setting_analog_modem_new ());
+		nm_connection_add_setting (connection, NM_SETTING (priv->setting));
+	}
+
+	g_signal_connect (self, "initialized", G_CALLBACK (finish_setup), NULL);
+	if (!ce_page_initialize (parent, NM_SETTING_ANALOG_MODEM_SETTING_NAME, error)) {
+		g_object_unref (self);
+		return NULL;
+	}
+
+	return CE_PAGE (self);
+}
+
+static const char *
+nm_entry_get_text (GtkEntry *entry)
+{
+	const char *txt;
+
+	txt = gtk_entry_get_text (entry);
+	if (txt && strlen (txt) > 0)
+		return txt;
+
+	return NULL;
+}
+
+static void
+ui_to_setting (CEPageModem *self)
+{
+	CEPageModemPrivate *priv = CE_PAGE_MODEM_GET_PRIVATE (self);
+
+	g_object_set (priv->setting,
+				  NM_SETTING_ANALOG_MODEM_PREFIX,          nm_entry_get_text (priv->prefix),
+				  NM_SETTING_ANALOG_MODEM_NUMBER,          nm_entry_get_text (priv->number),
+				  NM_SETTING_ANALOG_MODEM_USERNAME,        nm_entry_get_text (priv->username),
+				  NM_SETTING_ANALOG_MODEM_PASSWORD,        nm_entry_get_text (priv->password),
+				  NM_SETTING_ANALOG_MODEM_ENABLE_SPEAKER,  gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (priv->speaker)),
+				  NM_SETTING_ANALOG_MODEM_DETECT_DIALTONE, gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (priv->dialtone)),
+				  NULL);
+}
+
+static gboolean
+validate (CEPage *page, NMConnection *connection, GError **error)
+{
+	CEPageModem *self = CE_PAGE_MODEM (page);
+	CEPageModemPrivate *priv = CE_PAGE_MODEM_GET_PRIVATE (self);
+
+	ui_to_setting (self);
+	return nm_setting_verify (NM_SETTING (priv->setting), NULL, error);
+}
+
+static void
+dispose (GObject *object)
+{
+	CEPageModem *self = CE_PAGE_MODEM (object);
+	CEPageModemPrivate *priv = CE_PAGE_MODEM_GET_PRIVATE (self);
+
+	if (priv->window_group)
+		g_object_unref (priv->window_group);
+
+	G_OBJECT_CLASS (ce_page_modem_parent_class)->dispose (object);
+}
+
+static void
+ce_page_modem_init (CEPageModem *self)
+{
+}
+
+static void
+ce_page_modem_class_init (CEPageModemClass *modem_class)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (modem_class);
+	CEPageClass *parent_class = CE_PAGE_CLASS (modem_class);
+
+	g_type_class_add_private (object_class, sizeof (CEPageModemPrivate));
+
+	/* virtual methods */
+	parent_class->validate = validate;
+	object_class->dispose = dispose;
+}
diff --git a/src/connection-editor/page-modem.h b/src/connection-editor/page-modem.h
new file mode 100644
index 0000000..e7da5be
--- /dev/null
+++ b/src/connection-editor/page-modem.h
@@ -0,0 +1,54 @@
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* NetworkManager Connection editor -- Connection editor for NetworkManager
+ *
+ * Dan Williams <dcbw@redhat.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * (C) Copyright 2008 Red Hat, Inc.
+ */
+
+#ifndef __PAGE_MODEM_H__
+#define __PAGE_MODEM_H__
+
+#include <nm-connection.h>
+
+#include <glib.h>
+#include <glib-object.h>
+
+#include "ce-page.h"
+
+#define CE_TYPE_PAGE_MODEM            (ce_page_modem_get_type ())
+#define CE_PAGE_MODEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CE_TYPE_PAGE_MODEM, CEPageModem))
+#define CE_PAGE_MODEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CE_TYPE_PAGE_MODEM, CEPageModemClass))
+#define CE_IS_PAGE_MODEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CE_TYPE_PAGE_MODEM))
+#define CE_IS_PAGE_MODEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), CE_TYPE_PAGE_MODEM))
+#define CE_PAGE_MODEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CE_TYPE_PAGE_MODEM, CEPageModemClass))
+
+typedef struct {
+	CEPage parent;
+} CEPageModem;
+
+typedef struct {
+	CEPageClass parent;
+} CEPageModemClass;
+
+GType ce_page_modem_get_type (void);
+
+CEPage *ce_page_modem_new (NMConnection *connection,
+						   GtkWindow *parent,
+						   GError **error);
+
+#endif  /* __PAGE_MODEM_H__ */
diff --git a/src/utils/utils.c b/src/utils/utils.c
index e74af09..f9df4f6 100644
--- a/src/utils/utils.c
+++ b/src/utils/utils.c
@@ -27,6 +27,7 @@
 
 #include <nm-device-ethernet.h>
 #include <nm-device-wifi.h>
+#include <nm-device-analog-modem.h>
 #include <nm-gsm-device.h>
 #include <nm-cdma-device.h>
 #include <nm-access-point.h>
@@ -39,6 +40,7 @@
 #include <nm-setting-gsm.h>
 #include <nm-setting-cdma.h>
 #include <nm-setting-pppoe.h>
+#include <nm-setting-analog-modem.h>
 #include <nm-utils.h>
 
 #include "utils.h"
@@ -789,6 +791,23 @@ connection_valid_for_cdma (NMConnection *connection,
 	return TRUE;
 }
 
+static gboolean
+connection_valid_for_modem (NMConnection *connection,
+							NMSettingConnection *s_con,
+							NMDevice *device,
+							gpointer specific_object)
+{
+	NMSettingAnalogModem *s_modem;
+
+	if (strcmp (nm_setting_connection_get_connection_type (s_con), NM_SETTING_ANALOG_MODEM_SETTING_NAME))
+		return FALSE;
+
+	s_modem = NM_SETTING_ANALOG_MODEM (nm_connection_get_setting (connection, NM_TYPE_SETTING_ANALOG_MODEM));
+	g_return_val_if_fail (s_modem != NULL, FALSE);
+
+	return TRUE;
+}
+
 gboolean
 utils_connection_valid_for_device (NMConnection *connection,
                                    NMDevice *device,
@@ -811,6 +830,8 @@ utils_connection_valid_for_device (NMConnection *connection,
 		return connection_valid_for_gsm (connection, s_con, device, specific_object);
 	else if (NM_IS_CDMA_DEVICE (device))
 		return connection_valid_for_cdma (connection, s_con, device, specific_object);
+	else if (NM_IS_DEVICE_ANALOG_MODEM (device))
+		return connection_valid_for_modem (connection, s_con, device, specific_object);
 	else
 		g_warning ("Unknown device type '%s'", g_type_name (G_OBJECT_TYPE(device)));
 
